Index: kernel/arch/arm32/src/mach/testarm/testarm.c
===================================================================
--- kernel/arch/arm32/src/mach/testarm/testarm.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ kernel/arch/arm32/src/mach/testarm/testarm.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,256 @@
+/*
+ * Copyright (c) 2007 Michal Kebrt, Petr Stepan
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup arm32gxemul
+ * @{
+ */
+/** @file
+ *  @brief GXemul drivers.
+ */
+
+#include <arch/exception.h>
+#include <arch/mach/testarm/testarm.h>
+#include <mm/page.h>
+#include <mm/km.h>
+#include <genarch/fb/fb.h>
+#include <abi/fb/visuals.h>
+#include <genarch/drivers/dsrln/dsrlnin.h>
+#include <genarch/drivers/dsrln/dsrlnout.h>
+#include <genarch/srln/srln.h>
+#include <console/console.h>
+#include <ddi/irq.h>
+#include <ddi/device.h>
+#include <config.h>
+#include <sysinfo/sysinfo.h>
+#include <interrupt.h>
+#include <print.h>
+
+
+void *gxemul_kbd;
+void *gxemul_rtc;
+void *gxemul_irqc;
+static irq_t gxemul_timer_irq;
+
+struct arm_machine_ops gxemul_machine_ops = {
+	gxemul_init,
+	gxemul_timer_irq_start,
+	gxemul_cpu_halt,
+	gxemul_get_memory_extents,
+	gxemul_irq_exception,
+	gxemul_frame_init,
+	gxemul_output_init,
+	gxemul_input_init,
+	gxemul_get_irq_count,
+	gxemul_get_platform_name
+};
+
+void gxemul_init(void)
+{
+	gxemul_kbd = (void *) km_map(GXEMUL_KBD_ADDRESS, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	gxemul_rtc = (void *) km_map(GXEMUL_RTC_ADDRESS, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	gxemul_irqc = (void *) km_map(GXEMUL_IRQC_ADDRESS, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
+}
+
+void gxemul_output_init(void)
+{
+#ifdef CONFIG_FB
+	fb_properties_t prop = {
+		.addr = GXEMUL_FB_ADDRESS,
+		.offset = 0,
+		.x = 640,
+		.y = 480,
+		.scan = 1920,
+		.visual = VISUAL_RGB_8_8_8,
+	};
+	
+	outdev_t *fbdev = fb_init(&prop);
+	if (fbdev)
+		stdout_wire(fbdev);
+#endif
+	
+#ifdef CONFIG_ARM_PRN
+	outdev_t *dsrlndev = dsrlnout_init((ioport8_t *) gxemul_kbd);
+	if (dsrlndev)
+		stdout_wire(dsrlndev);
+#endif
+}
+
+void gxemul_input_init(void)
+{
+#ifdef CONFIG_ARM_KBD
+	/*
+	 * Initialize the GXemul keyboard port. Then initialize the serial line
+	 * module and connect it to the GXemul keyboard.
+	 */
+	dsrlnin_instance_t *dsrlnin_instance
+	    = dsrlnin_init((dsrlnin_t *) gxemul_kbd, GXEMUL_KBD_IRQ);
+	if (dsrlnin_instance) {
+		srln_instance_t *srln_instance = srln_init();
+		if (srln_instance) {
+			indev_t *sink = stdin_wire();
+			indev_t *srln = srln_wire(srln_instance, sink);
+			dsrlnin_wire(dsrlnin_instance, srln);
+		}
+	}
+	
+	/*
+	 * This is the necessary evil until the userspace driver is entirely
+	 * self-sufficient.
+	 */
+	sysinfo_set_item_val("kbd", NULL, true);
+	sysinfo_set_item_val("kbd.inr", NULL, GXEMUL_KBD_IRQ);
+	sysinfo_set_item_val("kbd.address.physical", NULL,
+	    GXEMUL_KBD_ADDRESS);
+#endif
+}
+
+size_t gxemul_get_irq_count(void)
+{
+	return GXEMUL_IRQ_COUNT;
+}
+
+const char *gxemul_get_platform_name(void)
+{
+	return "gxemul";
+}
+
+/** Starts gxemul Real Time Clock device, which asserts regular interrupts.
+ *
+ * @param frequency Interrupts frequency (0 disables RTC).
+ */
+static void gxemul_timer_start(uint32_t frequency)
+{
+	*((uint32_t *) (gxemul_rtc + GXEMUL_RTC_FREQ_OFFSET))
+	    = frequency;
+}
+
+static irq_ownership_t gxemul_timer_claim(irq_t *irq)
+{
+	return IRQ_ACCEPT;
+}
+
+/** Timer interrupt handler.
+ *
+ * @param irq Interrupt information.
+ * @param arg Not used.
+ */
+static void gxemul_timer_irq_handler(irq_t *irq)
+{
+	/*
+	* We are holding a lock which prevents preemption.
+	* Release the lock, call clock() and reacquire the lock again.
+	*/
+	spinlock_unlock(&irq->lock);
+	clock();
+	spinlock_lock(&irq->lock);
+	
+	/* acknowledge tick */
+	*((uint32_t *) (gxemul_rtc + GXEMUL_RTC_ACK_OFFSET))
+	    = 0;
+}
+
+/** Initializes and registers timer interrupt handler. */
+static void gxemul_timer_irq_init(void)
+{
+	irq_initialize(&gxemul_timer_irq);
+	gxemul_timer_irq.devno = device_assign_devno();
+	gxemul_timer_irq.inr = GXEMUL_TIMER_IRQ;
+	gxemul_timer_irq.claim = gxemul_timer_claim;
+	gxemul_timer_irq.handler = gxemul_timer_irq_handler;
+	
+	irq_register(&gxemul_timer_irq);
+}
+
+
+/** Starts timer.
+ *
+ * Initiates regular timer interrupts after initializing
+ * corresponding interrupt handler.
+ */
+void gxemul_timer_irq_start(void)
+{
+	gxemul_timer_irq_init();
+	gxemul_timer_start(GXEMUL_TIMER_FREQ);
+}
+
+/** Get extents of available memory.
+ *
+ * @param start		Place to store memory start address.
+ * @param size		Place to store memory size.
+ */
+void gxemul_get_memory_extents(uintptr_t *start, size_t *size)
+{
+	*start = 0;
+	*size = *((uintptr_t *) (GXEMUL_MP_ADDRESS + GXEMUL_MP_MEMSIZE_OFFSET));
+}
+
+/** Returns the mask of active interrupts. */
+static inline uint32_t gxemul_irqc_get_sources(void)
+{
+	return *((uint32_t *) gxemul_irqc);
+}
+
+/** Interrupt Exception handler.
+ *
+ * Determines the sources of interrupt and calls their handlers.
+ */
+void gxemul_irq_exception(unsigned int exc_no, istate_t *istate)
+{
+	uint32_t sources = gxemul_irqc_get_sources();
+	unsigned int i;
+	
+	for (i = 0; i < GXEMUL_IRQ_COUNT; i++) {
+		if (sources & (1 << i)) {
+			irq_t *irq = irq_dispatch_and_lock(i);
+			if (irq) {
+				/* The IRQ handler was found. */
+				irq->handler(irq);
+				spinlock_unlock(&irq->lock);
+			} else {
+				/* Spurious interrupt.*/
+				printf("cpu%d: spurious interrupt (inum=%d)\n",
+				    CPU->id, i);
+			}
+		}
+	}
+}
+
+void gxemul_cpu_halt(void)
+{
+	*((char *) (gxemul_kbd + GXEMUL_HALT_OFFSET)) = 0;
+}
+
+void gxemul_frame_init(void)
+{
+}
+
+/** @}
+ */
Index: kernel/arch/arm32/src/machine_func.c
===================================================================
--- kernel/arch/arm32/src/machine_func.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/machine_func.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,6 +41,5 @@
 #include <arch/mach/gta02/gta02.h>
 #include <arch/mach/integratorcp/integratorcp.h>
-#include <arch/mach/beagleboardxm/beagleboardxm.h>
-#include <arch/mach/beaglebone/beaglebone.h>
+#include <arch/mach/testarm/testarm.h>
 
 /** Pointer to machine_ops structure being used. */
@@ -52,10 +51,8 @@
 #if defined(MACHINE_gta02)
 	machine_ops = &gta02_machine_ops;
+#elif defined(MACHINE_testarm)
+	machine_ops = &gxemul_machine_ops;
 #elif defined(MACHINE_integratorcp)
 	machine_ops = &icp_machine_ops;
-#elif defined(MACHINE_beagleboardxm)
-	machine_ops = &bbxm_machine_ops;
-#elif defined(MACHINE_beaglebone)
-	machine_ops = &bbone_machine_ops;
 #else
 #error Machine type not defined.
@@ -134,10 +131,4 @@
 }
 
-const char * machine_get_platform_name(void)
-{
-	if (machine_ops->machine_get_platform_name)
-		return machine_ops->machine_get_platform_name();
-	return NULL;
-}
 /** @}
  */
Index: kernel/arch/arm32/src/mm/page.c
===================================================================
--- kernel/arch/arm32/src/mm/page.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/mm/page.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -52,16 +52,14 @@
 void page_arch_init(void)
 {
-	int flags = PAGE_CACHEABLE | PAGE_EXEC;
+	int flags = PAGE_CACHEABLE;
 	page_mapping_operations = &pt_mapping_operations;
 
 	page_table_lock(AS_KERNEL, true);
 	
+	uintptr_t cur;
+
 	/* Kernel identity mapping */
-	//FIXME: We need to consider the possibility that
-	//identity_base > identity_size and physmem_end.
-	//This might lead to overflow if identity_size is too big.
-	for (uintptr_t cur = PHYSMEM_START_ADDR;
-	    cur < min(KA2PA(config.identity_base) +
-	        config.identity_size, config.physmem_end);
+	for (cur = PHYSMEM_START_ADDR;
+	    cur < min(config.identity_size, config.physmem_end);
 	    cur += FRAME_SIZE)
 		page_mapping_insert(AS_KERNEL, PA2KA(cur), cur, flags);
Index: kernel/arch/arm32/src/mm/page_fault.c
===================================================================
--- kernel/arch/arm32/src/mm/page_fault.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/mm/page_fault.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -34,5 +34,4 @@
  */
 #include <panic.h>
-#include <arch/cp15.h>
 #include <arch/exception.h>
 #include <arch/mm/page_fault.h>
@@ -43,90 +42,39 @@
 #include <print.h>
 
-
-/**
- * FSR encoding ARM Architecture Reference Manual ARMv7-A and ARMv7-R edition.
+/** Returns value stored in fault status register.
  *
- * B3.13.3 page B3-1406 (PDF page 1406)
+ *  @return Value stored in CP15 fault status register (FSR).
  */
-typedef enum {
-	DFSR_SOURCE_ALIGN = 0x0001,
-	DFSR_SOURCE_CACHE_MAINTENANCE = 0x0004,
-	DFSR_SOURCE_SYNC_EXTERNAL_TRANSLATION_L1 = 0x000c,
-	DFSR_SOURCE_SYNC_EXTERNAL_TRANSLATION_L2 = 0x000e,
-	DFSR_SOURCE_SYNC_PARITY_TRANSLATION_L1 = 0x040c,
-	DFSR_SOURCE_SYNC_PARITY_TRANSLATION_L2 = 0x040e,
-	DFSR_SOURCE_TRANSLATION_L1 = 0x0005,
-	DFSR_SOURCE_TRANSLATION_L2 = 0x0007,
-	DFSR_SOURCE_ACCESS_FLAG_L1 = 0x0003,  /**< @note: This used to be alignment enc. */
-	DFSR_SOURCE_ACCESS_FLAG_L2 = 0x0006,
-	DFSR_SOURCE_DOMAIN_L1 = 0x0009,
-	DFSR_SOURCE_DOMAIN_L2 = 0x000b,
-	DFSR_SOURCE_PERMISSION_L1 = 0x000d,
-	DFSR_SOURCE_PERMISSION_L2 = 0x000f,
-	DFSR_SOURCE_DEBUG = 0x0002,
-	DFSR_SOURCE_SYNC_EXTERNAL = 0x0008,
-	DFSR_SOURCE_TLB_CONFLICT = 0x0400,
-	DFSR_SOURCE_LOCKDOWN = 0x0404, /**< @note: Implementation defined */
-	DFSR_SOURCE_COPROCESSOR = 0x040a, /**< @note Implementation defined */
-	DFSR_SOURCE_SYNC_PARITY = 0x0409,
-	DFSR_SOURCE_ASYNC_EXTERNAL = 0x0406,
-	DFSR_SOURCE_ASYNC_PARITY = 0x0408,
-	DFSR_SOURCE_MASK = 0x0000040f,
-} dfsr_source_t;
-
-static inline const char * dfsr_source_to_str(dfsr_source_t source)
+static inline fault_status_t read_fault_status_register(void)
 {
-	switch (source)	{
-	case DFSR_SOURCE_TRANSLATION_L1:
-		return "Translation fault L1";
-	case DFSR_SOURCE_TRANSLATION_L2:
-		return "Translation fault L2";
-	case DFSR_SOURCE_PERMISSION_L1:
-		return "Permission fault L1";
-	case DFSR_SOURCE_PERMISSION_L2:
-		return "Permission fault L2";
-	case DFSR_SOURCE_ALIGN:
-		return "Alignment fault";
-	case DFSR_SOURCE_CACHE_MAINTENANCE:
-		return "Instruction cache maintenance fault";
-	case DFSR_SOURCE_SYNC_EXTERNAL_TRANSLATION_L1:
-		return "Synchronous external abort on translation table walk level 1";
-	case DFSR_SOURCE_SYNC_EXTERNAL_TRANSLATION_L2:
-		return "Synchronous external abort on translation table walk level 2";
-	case DFSR_SOURCE_SYNC_PARITY_TRANSLATION_L1:
-		return "Synchronous parity error on translation table walk level 1";
-	case DFSR_SOURCE_SYNC_PARITY_TRANSLATION_L2:
-		return "Synchronous parity error on translation table walk level 2";
-	case DFSR_SOURCE_ACCESS_FLAG_L1:
-		return "Access flag fault L1";
-	case DFSR_SOURCE_ACCESS_FLAG_L2:
-		return "Access flag fault L2";
-	case DFSR_SOURCE_DOMAIN_L1:
-		return "Domain fault L1";
-	case DFSR_SOURCE_DOMAIN_L2:
-		return "Domain flault L2";
-	case DFSR_SOURCE_DEBUG:
-		return "Debug event";
-	case DFSR_SOURCE_SYNC_EXTERNAL:
-		return "Synchronous external abort";
-	case DFSR_SOURCE_TLB_CONFLICT:
-		return "TLB conflict abort";
-	case DFSR_SOURCE_LOCKDOWN:
-		return "Lockdown (Implementation defined)";
-	case DFSR_SOURCE_COPROCESSOR:
-		return "Coprocessor abort (Implementation defined)";
-	case DFSR_SOURCE_SYNC_PARITY:
-		return "Synchronous parity error on memory access";
-	case DFSR_SOURCE_ASYNC_EXTERNAL:
-		return "Asynchronous external abort";
-	case DFSR_SOURCE_ASYNC_PARITY:
-		return "Asynchronous parity error on memory access";
-	case DFSR_SOURCE_MASK:
-		break;
-	}
-	return "Unknown data abort";
+	fault_status_union_t fsu;
+	
+	/* fault status is stored in CP15 register 5 */
+	asm volatile (
+		"mrc p15, 0, %[dummy], c5, c0, 0"
+		: [dummy] "=r" (fsu.dummy)
+	);
+	
+	return fsu.fs;
 }
 
-#if defined(PROCESSOR_ARCH_armv4) | defined(PROCESSOR_ARCH_armv5)
+/** Returns FAR (fault address register) content.
+ *
+ * @return FAR (fault address register) content (address that caused a page
+ *         fault)
+ */
+static inline uintptr_t read_fault_address_register(void)
+{
+	uintptr_t ret;
+	
+	/* fault adress is stored in CP15 register 6 */
+	asm volatile (
+		"mrc p15, 0, %[ret], c6, c0, 0"
+		: [ret] "=r" (ret)
+	);
+	
+	return ret;
+}
+
 /** Decides whether read or write into memory is requested.
  *
@@ -149,5 +97,5 @@
 		panic("page_fault - instruction does not access memory "
 		    "(instr_code: %#0" PRIx32 ", badvaddr:%p).",
-		    *(uint32_t*)instr_union.instr, (void *) badvaddr);
+		    instr_union.pc, (void *) badvaddr);
 		return PF_ACCESS_EXEC;
 	}
@@ -188,5 +136,4 @@
 	    inst, (void *) badvaddr);
 }
-#endif
 
 /** Handles "data abort" exception (load or store at invalid address).
@@ -198,50 +145,16 @@
 void data_abort(unsigned int exc_no, istate_t *istate)
 {
-	const uintptr_t badvaddr = DFAR_read();
-	const fault_status_t fsr = { .raw = DFSR_read() };
-	const dfsr_source_t source = fsr.raw & DFSR_SOURCE_MASK;
+	fault_status_t fsr __attribute__ ((unused)) =
+	    read_fault_status_register();
+	uintptr_t badvaddr = read_fault_address_register();
 
-	switch (source)	{
-	case DFSR_SOURCE_TRANSLATION_L1:
-	case DFSR_SOURCE_TRANSLATION_L2:
-	case DFSR_SOURCE_PERMISSION_L1:
-	case DFSR_SOURCE_PERMISSION_L2:
-		/* Page fault is handled further down */
-		break;
-	case DFSR_SOURCE_ALIGN:
-	case DFSR_SOURCE_CACHE_MAINTENANCE:
-	case DFSR_SOURCE_SYNC_EXTERNAL_TRANSLATION_L1:
-	case DFSR_SOURCE_SYNC_EXTERNAL_TRANSLATION_L2:
-	case DFSR_SOURCE_SYNC_PARITY_TRANSLATION_L1:
-	case DFSR_SOURCE_SYNC_PARITY_TRANSLATION_L2:
-	case DFSR_SOURCE_ACCESS_FLAG_L1:
-	case DFSR_SOURCE_ACCESS_FLAG_L2:
-	case DFSR_SOURCE_DOMAIN_L1:
-	case DFSR_SOURCE_DOMAIN_L2:
-	case DFSR_SOURCE_DEBUG:
-	case DFSR_SOURCE_SYNC_EXTERNAL:
-	case DFSR_SOURCE_TLB_CONFLICT:
-	case DFSR_SOURCE_LOCKDOWN:
-	case DFSR_SOURCE_COPROCESSOR:
-	case DFSR_SOURCE_SYNC_PARITY:
-	case DFSR_SOURCE_ASYNC_EXTERNAL:
-	case DFSR_SOURCE_ASYNC_PARITY:
-	case DFSR_SOURCE_MASK:
-		/* Weird abort stuff */
-		fault_if_from_uspace(istate, "Unhandled abort %s at address: "
-		    "%#x.", dfsr_source_to_str(source), badvaddr);
-		panic("Unhandled abort %s at address: %#x.",
-		    dfsr_source_to_str(source), badvaddr);
+	pf_access_t access = get_memory_access_type(istate->pc, badvaddr);
+
+	int ret = as_page_fault(badvaddr, access, istate);
+
+	if (ret == AS_PF_FAULT) {
+		fault_if_from_uspace(istate, "Page fault: %#x.", badvaddr);
+		panic_memtrap(istate, access, badvaddr, NULL);
 	}
-
-#if defined(PROCESSOR_ARCH_armv6) | defined(PROCESSOR_ARCH_armv7_a)
-	const pf_access_t access =
-	    fsr.data.wr ? PF_ACCESS_WRITE : PF_ACCESS_READ;
-#elif defined(PROCESSOR_ARCH_armv4) | defined(PROCESSOR_ARCH_armv5)
-	const pf_access_t access = get_memory_access_type(istate->pc, badvaddr);
-#else
-#error "Unsupported architecture"
-#endif
-	as_page_fault(badvaddr, access, istate);
 }
 
@@ -254,5 +167,11 @@
 void prefetch_abort(unsigned int exc_no, istate_t *istate)
 {
-	as_page_fault(istate->pc, PF_ACCESS_EXEC, istate);
+	int ret = as_page_fault(istate->pc, PF_ACCESS_EXEC, istate);
+
+	if (ret == AS_PF_FAULT) {
+		fault_if_from_uspace(istate,
+		    "Page fault - prefetch_abort: %#x.", istate->pc);
+		panic_memtrap(istate, PF_ACCESS_EXEC, istate->pc, NULL);
+	}
 }
 
Index: kernel/arch/arm32/src/ras.c
===================================================================
--- kernel/arch/arm32/src/ras.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/arm32/src/ras.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -67,6 +67,5 @@
 void ras_check(unsigned int n, istate_t *istate)
 {
-	bool restart_needed = false;
-	uintptr_t restart_pc = 0;
+	uintptr_t rewrite_pc = istate->pc;
 
 	if (istate_from_uspace(istate)) {
@@ -74,15 +73,14 @@
 			if ((ras_page[RAS_START] < istate->pc) &&
 			    (ras_page[RAS_END] > istate->pc)) {
-				restart_needed = true;
-				restart_pc = ras_page[RAS_START];
+				rewrite_pc = ras_page[RAS_START];
 			}
 			ras_page[RAS_START] = 0;
 			ras_page[RAS_END] = 0xffffffff;
-		}
+		}	
 	}
 
 	exc_dispatch(n, istate);
-	if (restart_needed)
-		istate->pc = restart_pc;
+
+	istate->pc = rewrite_pc;
 }
 
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia32/Makefile.inc	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -105,3 +105,4 @@
 	arch/$(KARCH)/src/boot/memmap.c \
 	arch/$(KARCH)/src/fpu_context.c \
+	arch/$(KARCH)/src/debugger.c \
 	arch/$(KARCH)/src/syscall.c
Index: kernel/arch/ia32/include/arch/debugger.h
===================================================================
--- kernel/arch/ia32/include/arch/debugger.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ kernel/arch/ia32/include/arch/debugger.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,1 @@
+../../../amd64/include/arch/debugger.h
Index: kernel/arch/ia32/include/arch/istate.h
===================================================================
--- kernel/arch/ia32/include/arch/istate.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia32/include/arch/istate.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -68,10 +68,8 @@
 } istate_t;
 
-#define RPL_USER	3
-
 /** Return true if exception happened while in userspace */
 NO_TRACE static inline int istate_from_uspace(istate_t *istate)
 {
-	return (istate->cs & RPL_USER) == RPL_USER;
+	return !(istate->eip & UINT32_C(0x80000000));
 }
 
Index: kernel/arch/ia32/src/debugger.c
===================================================================
--- kernel/arch/ia32/src/debugger.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ kernel/arch/ia32/src/debugger.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,1 @@
+../../amd64/src/debugger.c
Index: kernel/arch/ia32/src/fpu_context.c
===================================================================
--- kernel/arch/ia32/src/fpu_context.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia32/src/fpu_context.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,31 +37,4 @@
 #include <arch.h>
 #include <cpu.h>
-
-
-/** x87 FPU scr values (P3+ MMX2) */
-enum {
-	X87_FLUSH_ZERO_FLAG = (1 << 15),
-	X87_ROUND_CONTROL_MASK = (0x3 << 13),
-	x87_ROUND_TO_NEAREST_EVEN = (0x0 << 13),
-	X87_ROUND_DOWN_TO_NEG_INF = (0x1 << 13),
-	X87_ROUND_UP_TO_POS_INF = (0x2 << 13),
-	X87_ROUND_TO_ZERO = (0x3 << 13),
-	X87_PRECISION_MASK = (1 << 12),
-	X87_UNDERFLOW_MASK = (1 << 11),
-	X87_OVERFLOW_MASK = (1 << 10),
-	X87_ZERO_DIV_MASK = (1 << 9),
-	X87_DENORMAL_OP_MASK = (1 << 8),
-	X87_INVALID_OP_MASK = (1 << 7),
-	X87_DENOM_ZERO_FLAG = (1 << 6),
-	X87_PRECISION_EXC_FLAG = (1 << 5),
-	X87_UNDERFLOW_EXC_FLAG = (1 << 4),
-	X87_OVERFLOW_EXC_FLAG = (1 << 3),
-	X87_ZERO_DIV_EXC_FLAG = (1 << 2),
-	X87_DENORMAL_EXC_FLAG = (1 << 1),
-	X87_INVALID_OP_EXC_FLAG = (1 << 0),
-
-	X87_ALL_MASK = X87_PRECISION_MASK | X87_UNDERFLOW_MASK | X87_OVERFLOW_MASK | X87_ZERO_DIV_MASK | X87_DENORMAL_OP_MASK | X87_INVALID_OP_MASK,
-};
-
 
 typedef void (*fpu_context_function)(fpu_context_t *fctx);
@@ -125,5 +98,4 @@
 }
 
-/** Initialize x87 FPU. Mask all exceptions. */
 void fpu_init()
 {
@@ -139,5 +111,5 @@
 		"ldmxcsr %[help0]\n"
 		: [help0] "+m" (help0), [help1] "+r" (help1)
-		: [magic] "i" (X87_ALL_MASK)
+		: [magic] "i" (0x1f80)
 	);
 }
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia32/src/ia32.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -45,4 +45,5 @@
 #include <arch/bios/bios.h>
 #include <arch/boot/boot.h>
+#include <arch/debugger.h>
 #include <arch/drivers/i8254.h>
 #include <arch/drivers/i8259.h>
@@ -117,4 +118,6 @@
 #endif
 		
+		/* Enable debugger */
+		debugger_init();
 		/* Merge all memory zones to 1 big zone */
 		zone_merge_all();
Index: kernel/arch/ia64/include/arch/istate.h
===================================================================
--- kernel/arch/ia64/include/arch/istate.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia64/include/arch/istate.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -106,6 +106,4 @@
 	uint64_t in5;
 	uint64_t in6;
-
-	uint64_t alignment;
 } istate_t;
 
Index: kernel/arch/ia64/include/arch/mm/as.h
===================================================================
--- kernel/arch/ia64/include/arch/mm/as.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia64/include/arch/mm/as.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -43,4 +43,6 @@
 #define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0xdfffffffffffffff)
 
+#define USTACK_ADDRESS_ARCH  UINT64_C(0x0000000ff0000000)
+
 typedef struct {
 } as_arch_t;
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -113,6 +113,6 @@
 	va = page;
 	
-	rr.word = rr_read(VA2VRN(page));
-	if ((restore_rr = (rr.map.rid != ASID2RID(asid, VA2VRN(page))))) {
+	rr.word = rr_read(VA2VRN(va));
+	if ((restore_rr = (rr.map.rid != ASID2RID(asid, VA2VRN(va))))) {
 		/*
 		 * The selected region register does not contain required RID.
@@ -122,6 +122,6 @@
 		
 		rr0 = rr;
-		rr0.map.rid = ASID2RID(asid, VA2VRN(page));
-		rr_write(VA2VRN(page), rr0.word);
+		rr0.map.rid = ASID2RID(asid, VA2VRN(va));
+		rr_write(VA2VRN(va), rr0.word);
 		srlz_d();
 		srlz_i();
@@ -139,38 +139,38 @@
 	case 1: /* cnt 4 - 15 */
 		ps = PAGE_WIDTH + 2;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	case 2: /* cnt 16 - 63 */
 		ps = PAGE_WIDTH + 4;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	case 3: /* cnt 64 - 255 */
 		ps = PAGE_WIDTH + 6;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	case 4: /* cnt 256 - 1023 */
 		ps = PAGE_WIDTH + 8;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	case 5: /* cnt 1024 - 4095 */
 		ps = PAGE_WIDTH + 10;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	case 6: /* cnt 4096 - 16383 */
 		ps = PAGE_WIDTH + 12;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	case 7: /* cnt 16384 - 65535 */
 	case 8: /* cnt 65536 - (256K - 1) */
 		ps = PAGE_WIDTH + 14;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	default:
 		ps = PAGE_WIDTH + 18;
-		va &= ~((1UL << ps) - 1);
+		va &= ~((1 << ps) - 1);
 		break;
 	}
 	
-	for (; va < (page + cnt * PAGE_SIZE); va += (1UL << ps))
+	for (; va < (page + cnt * PAGE_SIZE); va += (1 << ps))
 		asm volatile (
 			"ptc.l %[va], %[ps] ;;"
@@ -183,5 +183,5 @@
 	
 	if (restore_rr) {
-		rr_write(VA2VRN(page), rr.word);
+		rr_write(VA2VRN(va), rr.word);
 		srlz_d();
 		srlz_i();
@@ -501,5 +501,9 @@
 		 * Forward the page fault to address space page fault handler.
 		 */
-		as_page_fault(va, PF_ACCESS_EXEC, istate);
+		if (as_page_fault(va, PF_ACCESS_EXEC, istate) == AS_PF_FAULT) {
+			fault_if_from_uspace(istate, "Page fault at %p.",
+			    (void *) va);
+			panic_memtrap(istate, PF_ACCESS_EXEC, va, NULL);
+		}
 	}
 }
@@ -615,5 +619,9 @@
 		 * handler.
 		 */
-		as_page_fault(va, PF_ACCESS_READ, istate);
+		if (as_page_fault(va, PF_ACCESS_READ, istate) == AS_PF_FAULT) {
+			fault_if_from_uspace(istate, "Page fault at %p.",
+			    (void *) va);
+			panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, NULL);
+		}
 	}
 }
@@ -659,5 +667,9 @@
 		dtc_pte_copy(t);
 	} else {
-		as_page_fault(va, PF_ACCESS_WRITE, istate);
+		if (as_page_fault(va, PF_ACCESS_WRITE, istate) == AS_PF_FAULT) {
+			fault_if_from_uspace(istate, "Page fault at %p.",
+			    (void *) va);
+			panic_memtrap(istate, PF_ACCESS_WRITE, va, NULL);
+		}
 	}
 }
@@ -688,5 +700,9 @@
 		itc_pte_copy(t);
 	} else {
-		as_page_fault(va, PF_ACCESS_EXEC, istate);
+		if (as_page_fault(va, PF_ACCESS_EXEC, istate) == AS_PF_FAULT) {
+			fault_if_from_uspace(istate, "Page fault at %p.",
+			    (void *) va);
+			panic_memtrap(istate, PF_ACCESS_EXEC, va, NULL);
+		}
 	}
 }
@@ -748,5 +764,9 @@
 	ASSERT((t) && (t->p));
 	ASSERT(!t->w);
-	as_page_fault(va, PF_ACCESS_WRITE, istate);
+	if (as_page_fault(va, PF_ACCESS_WRITE, istate) == AS_PF_FAULT) {
+		fault_if_from_uspace(istate, "Page fault at %p.",
+		    (void *) va);
+		panic_memtrap(istate, PF_ACCESS_WRITE, va, NULL);
+	}
 }
 
@@ -779,5 +799,9 @@
 			dtc_pte_copy(t);
 	} else {
-		as_page_fault(va, PF_ACCESS_READ, istate);
+		if (as_page_fault(va, PF_ACCESS_READ, istate) == AS_PF_FAULT) {
+			fault_if_from_uspace(istate, "Page fault at %p.",
+			    (void *) va);
+			panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, NULL);
+		}
 	}
 }
Index: kernel/arch/ia64/src/proc/scheduler.c
===================================================================
--- kernel/arch/ia64/src/proc/scheduler.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/ia64/src/proc/scheduler.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -90,5 +90,5 @@
 		:
 		: "r" (&THREAD->kstack[STACK_SIZE / 2]),
-		  "r" (&THREAD->kstack[STACK_SIZE / 2])
+		  "r" (&THREAD->kstack[STACK_SIZE / 2 - SP_DELTA])
 		);
 }
Index: kernel/arch/mips32/include/arch/mm/tlb.h
===================================================================
--- kernel/arch/mips32/include/arch/mm/tlb.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/mips32/include/arch/mm/tlb.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -112,9 +112,9 @@
 #ifdef __BE__
 		unsigned p : 1;
-		unsigned : 25;
-		unsigned index : 6;
+		unsigned : 27;
+		unsigned index : 4;
 #else
-		unsigned index : 6;
-		unsigned : 25;
+		unsigned index : 4;
+		unsigned : 27;
 		unsigned p : 1;
 #endif
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/mips32/src/mips32.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -228,5 +228,5 @@
 {
 	supervisor_sp =
-	    (uintptr_t) &THREAD->kstack[STACK_SIZE];
+	    (uintptr_t) &THREAD->kstack[STACK_SIZE - SP_DELTA];
 }
 
